"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var React = require("react");
var Input = (function (_super) {
    __extends(Input, _super);
    function Input() {
        var _this = _super.call(this) || this;
        _this.submit = _this.submit.bind(_this);
        return _this;
    }
    Input.prototype.render = function () {
        return (React.createElement("div", { className: "input_label" },
            this.props.label ?
                React.createElement("label", null, this.props.label)
                : '',
            React.createElement("input", __assign({}, this.props, { className: "mb-standard", onKeyDown: this.submit }))));
    };
    Input.prototype.submit = function (ev) {
        if (ev.which == 13 && this.props.onSubmit) {
            ev.preventDefault();
            var tEvent = {
                target: ev.target
            };
            this.props.onSubmit(tEvent);
        }
    };
    return Input;
}(React.Component));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Input;
var InputWithOptions = (function (_super) {
    __extends(InputWithOptions, _super);
    function InputWithOptions() {
        var _this = _super.call(this) || this;
        _this.state = {
            options: []
        };
        _this.onInput = _this.onInput.bind(_this);
        _this.onChange = _this.onChange.bind(_this);
        return _this;
    }
    InputWithOptions.prototype.render = function () {
        var _this = this;
        var tOptions = this.state.options.map(function (option) {
            return React.createElement("div", { key: option.key, onClick: _this.onChange.bind(_this, option.key), "data-key": true }, option.value);
        });
        var tOpen = tOptions.length > 0 ? ' open' : '';
        return (React.createElement("div", { className: "InputWithOptions" },
            this.props.label ?
                React.createElement("label", null, this.props.label)
                : '',
            React.createElement("input", __assign({ className: "mb-standard" }, this.props, { onInput: this.onInput })),
            React.createElement("div", { className: "drop" + tOpen }, tOptions)));
    };
    InputWithOptions.prototype.onInput = function (val) {
        var _this = this;
        if (val) {
            if (this.timer) {
                window.clearTimeout(this.timer);
            }
            this.timer = window.setTimeout(function () {
                if (_this.props.getOptions) {
                    _this.timer = null;
                    _this.props.getOptions(val).then(function (data) {
                        _this.setState({
                            options: data
                        });
                    });
                }
            }, 200);
        }
        else {
            window.clearTimeout(this.timer);
            this.timer = null;
            this.setState({
                options: []
            });
        }
    };
    InputWithOptions.prototype.onChange = function (key) {
        this.setState({
            options: []
        });
        if (this.props.onChange) {
            this.props.onChange(key);
        }
    };
    return InputWithOptions;
}(React.Component));
exports.InputWithOptions = InputWithOptions;
//# sourceMappingURL=index.js.map